# -*- coding: utf-8 -*-
"""
Created on Sat Sep  7 17:11:00 2019

@author: Somaiya M. Ghoraibi
"""

#-------------  Used Libraaries ------------------------------------------
import pandas as pd
import gzip
import json
import nltk
import csv
import re
from nltk.corpus import stopwords
import numpy as np
import math
from nltk.corpus import stopwords
import pandas as pd
import datetime
from nltk.stem import PorterStemmer
from nltk.stem import WordNetLemmatizer
from itertools import chain
from nltk.corpus import wordnet
from nltk.tokenize import sent_tokenize, word_tokenize
from nltk.corpus import sentiwordnet as swn
#Code
Words = {}
Lexicon_pb = {}
Lexicon_it = {}
Lexicon_scaled = {}
Threshold = 10
Gamma = 4
#1: very negative / 2: negative / 4: positive / 5: very positive
Polarity = ['1', '2', '4', '5']


Count_review = 0
Count_pos_review = 0
Count_neg_review = 0
Count_pos_word = 0
Count_neg_word = 0

Filter_Words=[]
main_words=[]
Neg_Words=[]


CSV_path= 'C:\\Users\\Sumaia\\Desktop\\New folder\\DataSets\\Final DataSet\\Yelp\\All Yelp\yelp-dataset\\RestaurantReview1.csv'
fileSent = 'C:\\Users\\Sumaia\\Desktop\\New folder\\DataSets\\Final DataSet\\Yelp\\All Yelp\yelp-dataset\\RestaurantReview1.tsv'


#===================== Start of Load Data Function ============================== #
#This function read Json file that contain the dataset and insert it to pandas DataFrame to  ease their use then copy the content of the DataFrame to excel file
def collect_dataset() :
    #Source_file_path ="F:\\DataSets\\Final DataSet\\Amazon\\reviews_Movies_and_TV_5.json.gz"
    Source_file_path ="C:\\Users\\Sumaia\\Desktop\\New folder\\DataSets\\Final DataSet\\Yelp\\All Yelp\yelp-dataset\\yelp_academic_dataset_review.json"

    DataSetSize=1000000
    print (Source_file_path)
    loop=0 
    #open file    
    #file=open(Source_file_path,'r', encoding="utf8")  
    file=open(Source_file_path,'r', encoding="utf8")
  #======= This part to extract the data in json file to pandas dataframe work to ease the using then save it in excel file  
    #with open ( (CSV_path),'w') as csvfile:
    with open( fileSent,'wt', encoding="utf8") as out_file , open(CSV_path,'w', encoding="utf8") as csvfile:
         fieldnames = ['Word', 'SentimentScore']
         writer = csv.DictWriter(csvfile, fieldnames=fieldnames)        
         writer.writeheader()
         no=0
         p=0
         tsv_writer = csv.writer( out_file, delimiter='\t')
         for data in file:
            #print (loop)
            if(loop<=DataSetSize ): #loop how many rows u want to extract from the json file to put it in a dataframe    
                 xx=json.loads(data)
                 if (not ('review_id' in xx)):
                     ss='Noreview_id'
                 else:
                     ss= xx['review_id']
                 if (loop>=0):
                     if(xx['stars']==3):
                         p+=1
                    
                     if(xx['stars']!=3):
                         tsv_writer.writerow([int(xx['stars']), xx['text']])
                         writer.writerow({'Word':   int(xx['stars']), 
                             'SentimentScore': xx['text']
                            })
                        
                         no+=1
                         
           
                 if(loop%100000==0):
                     print (loop)
            
            
                 loop=loop+1
                      
            else :
                 print("Done Loading DataSet")
                 file.close()
                 break

    print("Done Loading DataSet")
    print (' Reviews read ' + str (no))
    print (' Reviews ==3 ' + str (p))

    file.close()
    out_file.close()
    
    
#-------------------------------
collect_dataset()




CSV_path='C:\\Users\\Sumaia\\Desktop\\Programming For Yelp\\Yelp - Restaurant\\Implicit_Rating_Aspect\\FullDataSet_ImplicitAspect.csv'
#df1=pd.read_csv(CSV_path1)
#df1.columns

arr=[]
def openfile_extractdata():
  
    df=pd.read_csv(CSV_path)
    print('Start loading Data....')
    print (df.shape[0])
    rows=0
    nanreview=0
   
    for i in range(df.shape[0]):  # df.shape give how many rows in the DataFrame
  
        Non_Empty_review=0
        #check if there is a text review or not(nan) value
        if (len(str(df.reviewText[i]))==3) :
            #print (str(i) )
            #print (df.reviewText[i])
            if('nan' in str(df.reviewText[i])): #-- nan means the cell of the reviewText in this row is empty
                print ('OHO')
                Non_Empty_review=1
                nanreview= nanreview+1
                print('*************')
                          
        if ( Non_Empty_review==0): # There is a reviewText in the current row 
            arr.append( df.reviewText[i]) 
            rows=rows+1
     
    print("Done : " + str (rows) + " Reviews is read" )
    print("Done : " + str ( nanreview) + " Reviews is Empty" )
    
    
#=====================End Extract data ===============
    
openfile_extractdata()

#===================== End of Load Data Function ============================== #
  
    
#-------------------------------
def hasNumbers(inputString):
    return any(char.isdigit() for char in inputString)
    
#*********** Start of global variables*******************
array_Nouns=[]


    
    

#*********** End of global variables*******************
    
def remove_stopwords(tokens):
    stopWords = set(stopwords.words('english'))
    words = [w for w in tokens if not w in stopWords]
    return words 

#remove punctuation from token
def remove_punctuation(token):
    result = ''.join([c if c.isalpha() else ' ' if c == '.' else '' for c in token])
    return result.strip().lower().split(' ') if len(result)>1 else None

    

#------------------------------
#Trial------------------------------
           
def processing_crazyletters(word):
    #print ('Start') 
    #print (word)
    woord=''
    
    #word='última'  åpnet  âme âges àgain âgée àcôté  øyet ørkenen  øyne ìndiebusinesses àcôté  ímuy ítems  çikolata çadéco àlacarte íbamos  çocukluunu ítens àlentrée àre ôte ýour
    #word='ýour' #          ôte ýour

    
    for c in word:
                   #print(c)
                   asc=ord(c)
                   #print (ord(c))
                   if (asc==233):
                        woord+='e'
                        
                   elif (asc==234):
                        woord+='e'
                   elif (asc==232):
                        woord+='e'
                   elif ((asc==228) | (asc==229) | (asc==226) | (asc==224)):
                        woord+='a'
                   elif (asc==225):
                        woord+='a'
                   elif (asc==231):
                        woord+='c'
                   elif ((asc==236)|(asc==238)|(asc==237)):
                        woord+='i'
                   elif (asc==252):
                        woord+='u'
                   elif (asc==250):
                        woord+='u'
                   elif (asc==253):
                        woord+='y'
                   elif (asc==246):
                        woord+='o'
                   elif ((asc==243) |(asc==244)|(asc==248)):
                        woord+='o'
                       
                   else:
                       woord+=c

    #print (woord)
    return (woord)



     

                    
#-----------------
def parse_review(text):
         
           tokenized=nltk.word_tokenize(text) 
           tagged_list=nltk.pos_tag( tokenized)
           tokens, tags = zip(*tagged_list)
           stop_words=set (stopwords.words("english"))
           words = []
           for w in text.split(' '):
               temp = remove_punctuation(w)
               if temp is not None:
                   words.extend([w for w in temp if w != ''])              
                   
           new_list=[]
           x=0
           k=-1
           for w1 in  words :
               k+=1
               found=0
               #print(w1)
               for i in range(k,(len(tokens))):
                   #print (w1+  '  ' +tokens[i]+ ' ' + tags[i])
                  # print(i)
                   if(w1==tokens[i].lower()):
                       #print('Yes')
                       #print (w1+  '  ' +tokens[i]+ ' ' + tags[i])
                       new_list.append((w1,tags[i]))
                       found=1
                       break
               if(found==0):
                       flag=0
                       length=len(w1)
                       w2=w1[:int(length/3)]
                       for i in range(k,(len(tokens))):
                           
                           if (tokens[i].lower().startswith(w2)):
                               #print('yyyyyyyyyyyyah  ' + tokens[i].lower())
                               new_list.append((w1,tags[i]))
                               flag=1
                               break

                       if (flag==0):
                            new_list.append((w1,'NON'))                                              
             
           clean_tokens=[]                     #
           for i in range (len(new_list)):
                      #print (str (i) + ' ' +new_list[i][0]+ '  ' +new_list[i][1])
                      if (new_list[i][0]  in Neg_Words):
                         clean_tokens.append((new_list[i][0],new_list[i][1],'1'))
                         #print('Taaaaaaaaaaaaaaaaaaaaaaaaaaaah')
                      elif (len( new_list[i][0])>2) and (new_list[i][0]  not in stop_words):
                          clean_tokens.append((new_list[i][0],new_list[i][1],'0'))
 
         
           SentimentScore=0
           SentScore=0
           no=0
           for word in clean_tokens: 
             tagger=word[1]
             wrd0=word[0]  
             asc=ord(wrd0[0])
             if (asc in [232,233,234,228,238,252,246,225,250,243,229,226,224,248,236,237,231,244,253]):
                 #print('Yes')
                 wrd=processing_crazyletters(wrd0)
             else:
                   wrd=wrd0
             #print (wrd)
             indicator_neg=word[2]     
             theta=1
             if (tagger.startswith('JJ')) or(tagger.startswith('R')) or(tagger.startswith('N')) or(tagger.startswith('V'))  or (indicator_neg=='1'):  #
                first_letter=str(wrd[0])
                ascii_firstletter= ord(first_letter.upper())
                block_no= ascii_firstletter-65
                ind=0
                wordscore=0
                if   ((block_no<27) and (block_no>=0))  :
                   for w in  Full_Block_Dictionary[ block_no]['Word']:
                     wordscore=0
                     if (wrd==w):
                        wordscore=Full_Block_Dictionary[ block_no]['SentimentScore'][ind]
                        no+=1
                        #print (w + '  :  ' + str(wordscore))
                        break
                     ind+=1
                else : 
                      
                       print ( wrd  + ' ***********  ' + str(block_no))
    
                SentScore+=wordscore
    
           SentimentScore=SentScore
           if (no >0):
               SentScore=SentScore/((no))
           else:
              SentScore=SentScore
        
           return(SentScore,SentimentScore)
           
       
#------------------       
       

#==============================================End trial


#-----------------------------------------    
  
#Blocking 
    
Full_Block_Dictionary=[{} for i in range(27)]

#Clear the list 
for i in range(27):
    Full_Block_Dictionary[i]['Word']=[]
    Full_Block_Dictionary[i]['SentimentScore']=[]
    
    

#*********** End of global variables*******************


#============================ Start building block ==============================


def blocking():
    global main_words
    special=0
    uniquewords=0
    for i in range(27):
        Full_Block_Dictionary[i]['Word']=[]
        Full_Block_Dictionary[i]['SentimentScore']=[]
    print('Start Blocking')
    for i in range(len (main_words)):
        word=str(main_words[i][0])
      
        first_letter=word[0]
        ascii_firstletter= ord(first_letter.upper())
        block_no= ascii_firstletter-65
        
        Flag=0
        new_word=''
        if   (block_no>=27) or (block_no<0)  :
           
            special=special+1
            print ('# Special =  ' + str(special) + '  ' +main_words[i][0] + '  in block no '+str(block_no) )
            new_word= processing_crazyletters(main_words[i][0])
            print (new_word)        
            
            first_letter=new_word[0]
            ascii_firstletter= ord(first_letter.upper())
            block_no= ascii_firstletter-65
            Flag=1
            
            

            
            
        if (Flag==1):
                    Full_Block_Dictionary[ block_no]['Word'].append(new_word)
        else:            
                    Full_Block_Dictionary[ block_no]['Word'].append(main_words[i][0])
        Full_Block_Dictionary[ block_no]['SentimentScore'].append(main_words[i][1])
        uniquewords=uniquewords+1
    print ('unique nouns = ' + str(uniquewords)) 
   


#============================ END building block ==============================+
    
#End blocking
        
        
        
        
        
        
        
        
        
        



#============================ END building block ==============================+
    
#End blocking


def parse_reviews():
  
  global SentimentScore

  global main_words
  main_words=[]
  New_array=[]
  #length=1196941
  length = 1000000 #80 training 1496177 Reviews is read 54 Reviews is Empty


  
  Neg_Words=[]
  #CSVPath3='F:\\NegationList.csv' 
  CSVPath3='C:\\Users\\Sumaia\\Desktop\\Programming For Yelp\\Yelp - Restaurant\\Lexicon\\NegationList.csv' 

  df3=pd.read_csv(CSVPath3) 
  for i in range (df3.shape[0]):
        if(i<df3.shape[0]):
            Neg_Words.append((df3.NWORDS[i])) 
  len(Neg_Words)
  
  print ('Start')
  #CSVPath2='F:\\Case2LExicon10.csv' 
  CSVPath2='C:\\Users\\Sumaia\\Desktop\\Programming For Yelp\\Yelp - Restaurant\\Lexicon\\Case2LExicon10.csv'
  df2=pd.read_csv(CSVPath2, encoding='latin-1') 
  #df2=df2.dropna()
  #df2=df2.reset_index()
  for i in range (df2.shape[0]):
        if(i<df2.shape[0]):
            main_words.append((df2.Word[i],df2.SentimentScore[i])) 
            
            
  blocking() 
  
 
  
  CSV_path='C:\\Users\\Sumaia\\Desktop\\Programming For Yelp\\Yelp - Restaurant\\Implicit_Rating_Aspect\\FullDataSet_ImplicitAspect.csv'
  df=pd.read_csv(CSV_path)
  df.columns
  #i=0
  s=[]
  main_array=[]
  for i in range (df.shape[0]): 

        #print (i)
        if(len( df.reviewText[i])>1):
         
                     x,y=parse_review( df.reviewText[i])
                     

                     main_array.append((i, df.reviewText[i],x,y))
                     s.append(y)
                        
                     if(i%10000==0):
                         currentDT = datetime.datetime.now() 
                         print (' review '+ str (i) + ' is processed at '+ str( currentDT)) 
       
       
       
   
      
  
       
  
  with  open('C:\\Users\\Sumaia\\Desktop\\Programming For Yelp\\Yelp - Restaurant\\ImplicitRatingUsingSentimentWord.csv','w') as csvfile:

         fieldnames = ['Review', 'Rating','SentimentScoredividenoofwords','SentimentScore']
         writer = csv.DictWriter(csvfile, fieldnames=fieldnames)        
         writer.writeheader()
         #for i in range(size):#part1
         #for i in range(size,size2):#part2
         for i in (range(len(main_array))):#part3
              writer.writerow({'Review':   main_array[i][0],
                               'Rating':main_array[i][1],
                               'SentimentScoredividenoofwords': main_array[i][2],
                               'SentimentScore': main_array[i][3]
                            }) 
    
  csvfile.close()
      


#--------------------------------------------------------------------
 
 